<html>
<head>
  <title>./4_wifi/main.c</title>
</head>
<body bgcolor="#ffffff" text="#000000">
<pre>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-base-info.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-wifi-info.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-wifi-rescan.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;pthread.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;signal.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;stdio.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;stdlib.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;string.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;unistd.h&gt;</font></strong></font>

<strong>void</strong> <font color="#2040a0">usage</font><font color="4444FF">(</font><strong>void</strong><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;USAGE: info [Interface Name]<font color="#77dd77">\n</font>&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">rescan_ap_list</font><font color="4444FF">(</font><strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">interface_name</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <strong>return</strong> <font color="#2040a0">mcm_wifi_rescan</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font><font color="4444FF">)</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">show_ap_list</font><font color="4444FF">(</font><strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">interface_name</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <strong>int</strong>          <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font>
    <strong>int</strong>          <font color="#2040a0">num</font><font color="4444FF">;</font>
    <font color="#2040a0">mcm_wifi_ap</font> <font color="4444FF">*</font><font color="#2040a0">apilist</font><font color="4444FF">;</font>

    <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_get_wifi_aplist</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">num</font>, <font color="4444FF">&amp;</font><font color="#2040a0">apilist</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">ret</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;ERROR: Get wifi ap list failed:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">ret</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="4444FF">-</font><font color="#FF0000">1</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Number:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">num</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <strong>for</strong> <font color="4444FF">(</font><strong>int</strong> <font color="#2040a0">i</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font> <font color="#2040a0">i</font> <font color="4444FF">&lt;</font> <font color="#2040a0">num</font><font color="4444FF">;</font> <font color="#2040a0">i</font><font color="4444FF">+</font><font color="4444FF">+</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;[%d]<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">i</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;<font color="#77dd77">\t</font>ssid:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">apilist</font><font color="4444FF">[</font><font color="#2040a0">i</font><font color="4444FF">]</font>.<font color="#2040a0">ssid</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;<font color="#77dd77">\t</font>bssid:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">apilist</font><font color="4444FF">[</font><font color="#2040a0">i</font><font color="4444FF">]</font>.<font color="#2040a0">bssid</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;<font color="#77dd77">\t</font>Encryption:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">apilist</font><font color="4444FF">[</font><font color="#2040a0">i</font><font color="4444FF">]</font>.<font color="#2040a0">encryption_type</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;<font color="#77dd77">\t</font>Signal Strength:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">apilist</font><font color="4444FF">[</font><font color="#2040a0">i</font><font color="4444FF">]</font>.<font color="#2040a0">signal_strength</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>
    <font color="#2040a0">free</font><font color="4444FF">(</font><font color="#2040a0">apilist</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>return</strong> <font color="#FF0000">0</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">main</font><font color="4444FF">(</font><strong>int</strong> <font color="#2040a0">argc</font>, <strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="4444FF">]</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">argc</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">2</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">usage</font><font color="4444FF">(</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="4444FF">-</font><font color="#FF0000">1</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <font color="#2040a0">rescan_ap_list</font><font color="4444FF">(</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">1</font><font color="4444FF">]</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">sleep</font><font color="4444FF">(</font><font color="#FF0000">5</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>return</strong> <font color="#2040a0">show_ap_list</font><font color="4444FF">(</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">1</font><font color="4444FF">]</font><font color="4444FF">)</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

</pre>
<hr>
syntax highlighted by <a href="http://www.palfrader.org/code2html">Code2HTML</a>, v. 0.9.1
</body>
</html>
